package com.ynet.life.sujrb.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.DuplicatedDataNameException;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.InvalidArgumentException;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.base.LifeAction;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class CalculateBeforeMonthAction extends LifeAction {

   private String currDate;
   private String calType;
   private String calMon;
   private String iCollName;
   private static final String TYPE_M = "1";


   public String execute(Context currDateM) throws GENEException {
      try {
         IndexedCollection e = (IndexedCollection)currDateM.getDataElement(this.iCollName);
         String var11 = (String)currDateM.getDataValue(this.currDate);
         if("1".equals(this.calType)) {
            try {
               SimpleDateFormat e1 = new SimpleDateFormat("yyyyMMdd");
               SimpleDateFormat format1 = new SimpleDateFormat("yyyyMM");
               SimpleDateFormat format2 = new SimpleDateFormat("yyyy");
               Date var12 = e1.parse(var11);
               int var13 = Integer.parseInt(this.calMon);

               for(int i = 0; i <= var13; ++i) {
                  KeyedCollection retKcoll = new KeyedCollection();
                  Calendar now;
                  (now = Calendar.getInstance()).setTime(var12);
                  now.set(2, now.get(2) - i);
                  retKcoll.put("currDate", format1.format(now.getTime()));
                  retKcoll.put("currYear", format2.format(now.getTime()));
                  e.add(retKcoll);
               }
            } catch (ParseException var9) {
               Trace.log("LifeAction", "银行月报跑批日期处理异常");
               throw var9;
            }
         }

         return "0";
      } catch (Exception var10) {
         Trace.logError("LifeAction", "银行月报跑批历史数据日期处理异常出错", var10);
         throw new TranFailException("RZPT90013", "银行月报跑批历史数据日期处理异常出错", false);
      }
   }

   public String getCurrDate() {
      return this.currDate;
   }

   public void setCurrDate(String currDate) {
      this.currDate = currDate;
   }

   public String getICollName() {
      return this.iCollName;
   }

   public void setICollName(String iCollName) {
      this.iCollName = iCollName;
   }

   public String getCalType() {
      return this.calType;
   }

   public void setCalType(String calType) {
      this.calType = calType;
   }

   public String getCalMon() {
      return this.calMon;
   }

   public void setCalMon(String calMon) {
      this.calMon = calMon;
   }

   public static void main(String[] currDateM) throws ParseException, InvalidArgumentException, DuplicatedDataNameException {
      SimpleDateFormat var6 = new SimpleDateFormat("yyyyMMdd");
      SimpleDateFormat MFormat = new SimpleDateFormat("yyyyMM");
      Date var7 = var6.parse("20170206");
      IndexedCollection icoll = new IndexedCollection();

      for(int i = 0; i <= 24; ++i) {
         KeyedCollection retKcoll = new KeyedCollection();
         Calendar now;
         (now = Calendar.getInstance()).setTime(var7);
         now.set(2, now.get(2) - i);
         retKcoll.put("currDate", MFormat.format(now.getTime()));
         icoll.add(retKcoll);
      }

      System.out.println(icoll.toString());
   }
}
